=== debian/changelog ===
sumo (1.8.0+dfsg2-5) unstable; urgency=medium

  * [4a4b462] Add Breaks+Replaces: sumo (<< 1.8) for sumo-tools.
              (Closes: #980845)
  * [ee90f08] Allow reprotest to fail

 -- Anton Gladky <gladk@debian.org>  Sat, 23 Jan 2021 11:47:24 +0100

sumo (1.8.0+dfsg2-4) unstable; urgency=medium

  * [2d44042] Fix d/rules

 -- Anton Gladky <gladk@debian.org>  Fri, 22 Jan 2021 22:53:50 +0100

sumo (1.8.0+dfsg2-3) unstable; urgency=medium

  * [3c87058] No debug info for mipsel

 -- Anton Gladky <gladk@debian.org>  Thu, 21 Jan 2021 16:59:56 +0100

sumo (1.8.0+dfsg2-2) unstable; urgency=medium

  * [e62ac20] Do not run autotests in indep-mode
  * [6836a98] No debug info for mip* to avoid out of memory

 -- Anton Gladky <gladk@debian.org>  Wed, 20 Jan 2021 18:48:58 +0100

sumo (1.8.0+dfsg2-1) unstable; urgency=medium

  * [e563f46] New upstream version 1.8.0+dfsg2
  * [567c39a] Refresh patches
  * [16b858e] Update d/copyright
  * [c482b16] Remove d/clean
  * [7158927] Fix test
  * [6a5c16a] Update d/control
  * [71e2d68] Update d/rules
  * [f4f4e02] Add .gitlab-ci.yml
  * [a2fc178] Remove dh_make template from debian watch.
  * [2ca5f9b] Use secure URI in Homepage field.
  * [f890de3] Remove deprecated Encoding key from desktop file debian/sumo.desktop.
  * [fdd3cbe] Update standards version to 4.5.0, no changes needed.
  * [cbcd430] Set Standards-Version to 4.5.1

 -- Anton Gladky <gladk@debian.org>  Tue, 05 Jan 2021 20:48:37 +0100
