=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\.dfsg// https://github.com/eclipse/sumo/tags .*/v?(\d\S+)\.tar\.gz
